vgp.curve.common

## Class PjCurve

- java.lang.Object
- - jv.object.PsObject
  - - jv.project.PjProject
    - - vgp.curve.common.PjCurve

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, PsTimeListenerIf, PsUpdateIf, PvPickListenerIf
  Direct Known Subclasses:
    PjSurfCurve

      public class PjCurve
      extends PjProject

  Compute differential geometric curves on hyper surfaces given by an ordinary differential equation.
  See Also:
    Serialized Form
  Version:
    09.01.02, 1.30 revised (ep) Set length of curve to something reasonable whenever a surface is assigned to this project.
    16.09.00, 1.20 revised (kp) Animation removed since unused.
    28.01.00, 1.12 revised (kp) Initial points of curve modified to ensure position inside domain.
    01.11.99, 1.11 revised (kp) Construction of ODE moved from computeCurve() to selectCurve().
    05.07.99, 1.10 revised (kp) Method getSurfaceName() added Instance variable m_surfaceName added. Tabbed panels added to info panel. m_geom.setParent(this) added and corresponding update handling.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `ASYMPTOTIC`
    `static java.lang.String` | `BASE_SURFACE_NAME`
    `static int` | `GEODESIC` Types of curves.
    `static int` | `PRINCIPAL_CURVATURE`
    `static int` | `SHADOW`

    - ### Fields inherited from class jv.object.PsObject

      `HAS_BOUNDARY_PANEL, HAS_CONFIG_PANEL, HAS_INFO_PANEL, HAS_LABEL_PANEL, HAS_MATERIAL_PANEL, HAS_TEXTURE_PANEL, HAS_VECTOR_PANEL, INSPECTOR_INFO, INSPECTOR_INFO_EXT, IS_DELETED, IS_FIXED, IS_FOCUSSED, IS_PICKED, IS_SELECTED, IS_USED, NUM_TAGS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PjCurve()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `calculateCurve()`
    `java.lang.String` | `getSurfaceName()`
    `void` | `init()` Initialize and reset project, stops the running animation if any.
    `void` | `pickInitial(PvPickEvent pos)` 22.6.99: pick a point everywhere on the surface.
    `boolean` | `selectCurve(int sel)`
    `boolean` | `setSurfaceName(java.lang.String surfaceName)` Set name of base surface on which curve will be computed.
    `void` | `start()` Method is invoked during loading of a project in JavaView.
    `boolean` | `update(java.lang.Object event)` Update the class whenever a child has changed.

    - ### Methods inherited from class jv.project.PjProject

      `addDisplay, addGeometry, addGeometry, dispose, dragDisplay, dragInitial, dragVertex, fitDisplays, getAnimation, getDisplay, getDisplays, getGeometry, getGeometry, getNumGeometries, getParameter, getParameterInfo, getViewer, hasAnimation, hasDisplay, isEnabledAutoFit, markVertices, pickDisplay, pickVertex, removeDisplay, removeGeometries, removeGeometry, selectDisplay, selectGeometry, setAnimation, setBackColor, setBorderType, setDisplay, setEnabledAutoFit, setGeometry, setParameterInfo, setTime, setViewer, stop, unmarkVertices`

    - ### Methods inherited from class jv.object.PsObject

      `addInspector, addUpdateListener, assureInspector, clearTag, clone, clone, clone, copy, getFather, getInfoPanel, getInspector, getName, getNumObjects, getSymbol, hasInspector, hasTag, hasUpdateListener, instanceOf, instanceOf, newInspector, newInspector, removeInspector, removeInspector, removeUpdateListener, setName, setParent, setSymbol, setTag, toString, updatePanels`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface jv.anim.PsTimeListenerIf

      `getName`

    - ### Methods inherited from interface jv.project.PvPickListenerIf

      `getName`

- - ### Field Detail

    - #### GEODESIC

          public static final int GEODESIC

      Types of curves.
      See Also:
        Constant Field Values

    - #### SHADOW

          public static final int SHADOW

      See Also:
        Constant Field Values

    - #### ASYMPTOTIC

          public static final int ASYMPTOTIC

      See Also:
        Constant Field Values

    - #### PRINCIPAL_CURVATURE

          public static final int PRINCIPAL_CURVATURE

      See Also:
        Constant Field Values

    - #### BASE_SURFACE_NAME

          public static final java.lang.String BASE_SURFACE_NAME

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### PjCurve

          public PjCurve()

  - ### Method Detail

    - #### init

          public void init()

      Description copied from class: `PjProject`
      Initialize and reset project, stops the running animation if any. Does not reset any registered display nor geometry. They must be reset individually in each subclass.
      Overrides:
        `init` in class `PjProject`

    - #### start

          public void start()

      Description copied from class: `PjProject`
      Method is invoked during loading of a project in JavaView.

      If a project has an animation object, then the animation panel is shown when the project's this start() method is invoked during loading of the project. Use `setAnimation(PsAnimation)` to register an animation.

      If auto fit is enabled then scenery is scaled to fit in each display.

      Overrides:
        `start` in class `PjProject`
      See Also:
        `PvViewerIf.start()`, `PjProject.isEnabledAutoFit()`

    - #### update

          public boolean update(java.lang.Object event)

      Update the class whenever a child has changed. Method is usually invoked from the children.
      Specified by:
        `update` in interface `PsUpdateIf`
      Overrides:
        `update` in class `PsObject`
      Parameters:
        `event` - carries a lot of information
      Returns:
        true if event has been handled, otherwise false
      See Also:
        `PsObject.setParent(PsUpdateIf)`, `PsObject.getFather()`, `PsObject.addUpdateListener(PsUpdateIf)`

    - #### getSurfaceName

          public java.lang.String getSurfaceName()

    - #### setSurfaceName

          public boolean setSurfaceName(java.lang.String surfaceName)

      Set name of base surface on which curve will be computed. Name of surface must be among existing set of surface classes in package vgp.surface.common.PgSurface_XXX.
      Parameters:
        `surfaceName` - Name of existing surface class
      Returns:
        true on success

    - #### selectCurve

          public boolean selectCurve(int sel)

    - #### calculateCurve

          public void calculateCurve()

      Author:
        Eike Preuss
      Version:
        16.07.99 revised (kp) Update modified such that info panels get updated.
        16.07.99 revised (kp) Check for polygons with discretization less than 2.
        00.00.99 created (ep)

    - #### pickInitial

          public void pickInitial(PvPickEvent pos)

      22.6.99: pick a point everywhere on the surface.
      Specified by:
        `pickInitial` in interface `PvPickListenerIf`
      Overrides:
        `pickInitial` in class `PjProject`
      Parameters:
        `pos` - Pick event issued by the display
      See Also:
        `PvPickListenerIf`

"

The software JavaView? is copyright protected. All Rights Reserved.
"